<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>tubafashe-api documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">tubafashe-api documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>CurrencyRateService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/payment/service/currency-rate.service.ts</code>
        </p>




            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#currencyApiGot">currencyApiGot</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Public</span>
                                    <span class="modifier">Async</span>
                                <a href="#getCurrencyRate">getCurrencyRate</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                <a href="#getDiffBetween2Dates">getDiffBetween2Dates</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Async</span>
                                <a href="#getLatestCurrencyRate">getLatestCurrencyRate</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(configBucket: <a href="../classes/ConfigBucket.html">ConfigBucket</a>, appLogger: <a href="../injectables/AppLogger.html">AppLogger</a>, currencyRateRepository: <a href="../classes/CurrencyRate.html">Repository<CurrencyRate></a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="13" class="link-to-prism">src/payment/service/currency-rate.service.ts:13</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>configBucket</td>
                                                  
                                                        <td>
                                                                        <code><a href="../classes/ConfigBucket.html" target="_self" >ConfigBucket</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>appLogger</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/AppLogger.html" target="_self" >AppLogger</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>currencyRateRepository</td>
                                                  
                                                        <td>
                                                                        <code><a href="../classes/CurrencyRate.html" target="_self" >Repository&lt;CurrencyRate&gt;</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getCurrencyRate"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            <span class="modifier">Async</span>
                            getCurrencyRate
                        </b>
                        <a href="#getCurrencyRate"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getCurrencyRate()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="29"
                            class="link-to-prism">src/payment/service/currency-rate.service.ts:29</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;CurrencyRateResponseDto&gt;</code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getDiffBetween2Dates"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            <span class="modifier">Static</span>
                            getDiffBetween2Dates
                        </b>
                        <a href="#getDiffBetween2Dates"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getDiffBetween2Dates(date1: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="67"
                            class="link-to-prism">src/payment/service/currency-rate.service.ts:67</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>date1</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getLatestCurrencyRate"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            <span class="modifier">Async</span>
                            getLatestCurrencyRate
                        </b>
                        <a href="#getLatestCurrencyRate"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getLatestCurrencyRate()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="51"
                            class="link-to-prism">src/payment/service/currency-rate.service.ts:51</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;CurrencyRateResponseDto&gt;</code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="currencyApiGot"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            currencyApiGot</b>
                            <a href="#currencyApiGot"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Got</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="13" class="link-to-prism">src/payment/service/currency-rate.service.ts:13</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@nestjs/common&#x27;;
import { CurrencyRateResponseDto } from &#x27;../dto/currency-rate-response.dto&#x27;;
import got, { Got } from &#x27;got&#x27;;
import { ConfigBucket } from &#x27;../../common/config-bucket&#x27;;
import { AppLogger } from &#x27;../../common/app-logger&#x27;;
import { InjectRepository } from &#x27;@nestjs/typeorm&#x27;;
import { CurrencyRate } from &#x27;../entity/currency-rate.entity&#x27;;
import { Repository } from &#x27;typeorm&#x27;;
import { ServiceUnavaibleException } from &#x27;../../common/exception/service-unavaible.exception&#x27;;

@Injectable()
export class CurrencyRateService {
  private readonly currencyApiGot: Got;

  constructor(private readonly configBucket: ConfigBucket,
              private appLogger: AppLogger,
              @InjectRepository(CurrencyRate)
              private readonly currencyRateRepository: Repository&lt;CurrencyRate&gt;,
  ) {
    this.appLogger.setContext(&#x27;CurrencyRateService&#x27;);
    this.currencyApiGot &#x3D; got.extend({
      prefixUrl: this.configBucket.CURRENCY_API_URL,
      headers: {
        &#x27;Content-Type&#x27;: &#x27;application/json&#x27;,
      },
    });
  }

  public async getCurrencyRate(): Promise&lt;CurrencyRateResponseDto&gt; {
    try {
      this.appLogger.log(&#x27;getCurrencyRate&#x27;);
      const currencyRate: CurrencyRate &#x3D; await this.currencyRateRepository.findOne({value: &#x27;latest&#x27;});
      if (currencyRate) {
           const numberOfDaysSinceLastUpd &#x3D; CurrencyRateService.getDiffBetween2Dates(currencyRate.updateAt);
           if (numberOfDaysSinceLastUpd &gt; 1) {
             return this.getLatestCurrencyRate();
           } else {
             const currencyRateResponseDto &#x3D; new CurrencyRateResponseDto();
             currencyRateResponseDto.rates &#x3D; currencyRate.rates;
             return currencyRateResponseDto;
           }
      } else {
        return this.getLatestCurrencyRate();
      }

    } catch (e) {
      this.appLogger.error(&#x27;getCurrencyRate: &#x27; + e.toString());
    }
  }

  private async getLatestCurrencyRate(): Promise&lt;CurrencyRateResponseDto&gt; {
    this.appLogger.log(&#x27;getLatestCurrencyRate&#x27;);
    const url &#x3D; &#x27;/latest?access_key&#x3D;&#x27; + this.configBucket.CURRENCY_API_KEY + &#x27;&amp;symbols&#x3D;USD,XOF,RWF&#x27;;
    const response: CurrencyRateResponseDto &#x3D; await this.currencyApiGot.get(url).json&lt;CurrencyRateResponseDto&gt;();
    if (!response.success) {
        throw new ServiceUnavaibleException(response.error.info);
    }
    if (response.success &#x3D;&#x3D;&#x3D; true) {
        const newCurrencyRate: CurrencyRate &#x3D; new CurrencyRate();
        newCurrencyRate.value &#x3D; &#x27;latest&#x27;;
        newCurrencyRate.rates &#x3D; response.rates;
        await this.currencyRateRepository.save(newCurrencyRate);
        return response;
    }
  }

  private static getDiffBetween2Dates(date1: string): number {
    const dt1 &#x3D; new Date(date1);
    const dt2 &#x3D; new Date();

    return Math.floor((Date.UTC(dt2.getFullYear(), dt2.getMonth(),
      dt2.getDate()) - Date.UTC(dt1.getFullYear(), dt1.getMonth(),
      dt1.getDate()) ) / (1000 * 60 * 60 * 24));
  }
}
</code></pre>
    </div>

</div>







                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'CurrencyRateService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
